Backend API
$(() => {
$('#grid').dxDataGrid({
dataSource: orders,
keyExpr: 'ID',
showBorders: true,
height: '100%',
paging: {
pageSize: 8,
},
scrolling: {
mode: 'virtual',
},
columns: [{
allowGrouping: false,
dataField: 'OrderNumber',
caption: 'Invoice Number',
width: 130,
}, {
caption: 'City',
dataField: 'CustomerStoreCity',
}, {
caption: 'State',
dataField: 'CustomerStoreState',
},
'Employee', {
dataField: 'OrderDate',
dataType: 'date',
}, {
dataField: 'SaleAmount',
format: 'currency',
}],
});
const resizable = $('#gridContainer').dxResizable({
minWidth: 400,
minHeight: 150,
maxHeight: 370,
area: '.widget-container .dx-field',
}).dxResizable('instance');
$('#keepAspectRatio').dxCheckBox({
text: 'Keep aspect ratio',
value: true,
onValueChanged: ({ value }) => {
resizable.option('keepAspectRatio', value);
},
});
const allHandles = ['left', 'top', 'right', 'bottom'];
$('#handles').dxTagBox({
items: allHandles,
value: allHandles,
inputAttr: { 'aria-label': 'Handle' },
onValueChanged: ({ value }) => {
const resizableClasses = allHandles.reduce((classes, handle) => {
const newClass = value.includes(handle) ? '' : ` no-${handle}-handle`;
return classes + newClass;
}, '');
resizable.option({
handles: value.join(' '),
elementAttr: {
class: resizableClasses,
},
});
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="js/dx.all.js?v=25.2.6"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="widget-container">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Resizable DataGrid</div>
<div class="dx-field">
<div id="gridContainer">
<div id="grid"></div>
</div>
</div>
</div>
</div>
<div class="options">
<div class="caption">Resizable Options</div>
<div class="option">
<div>Handles</div>
<div id="handles"></div>
</div>
<div class="option">
<div id="keepAspectRatio"></div>
</div>
</div>
</div>
</body>
</html>
.widget-container {
width: calc(100% - 360px);
height: 100%;
margin-right: 320px;
position: absolute;
z-index: 1501;
}
.dx-fieldset,
.dx-field {
width: 100%;
height: calc(100% - 60px);
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
bottom: 0;
width: 260px;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 10px;
}
#gridContainer {
padding: 10px;
height: 300px;
}
#grid {
border: 1px solid black;
}
.no-left-handle .dx-resizable-handle-top,
.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 10px);
}
.no-right-handle .dx-resizable-handle-top,
.no-right-handle .dx-resizable-handle-bottom {
right: 10px;
width: calc(100% - 10px);
}
.no-right-handle.no-left-handle .dx-resizable-handle-top,
.no-right-handle.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 20px);
}
.no-top-handle .dx-resizable-handle-right,
.no-top-handle .dx-resizable-handle-left {
top: 10px;
height: calc(100% - 10px);
}
.no-bottom-handle .dx-resizable-handle-right,
.no-bottom-handle .dx-resizable-handle-left {
bottom: 10px;
height: calc(100% - 10px);
}
.no-top-handle.no-bottom-handle .dx-resizable-handle-left,
.no-top-handle.no-bottom-handle .dx-resizable-handle-right {
top: 10px;
height: calc(100% - 20px);
}
.dx-resizable-handle-right {
border-right: 1px dotted #999;
}
.dx-resizable-handle-top {
border-top: 1px dotted #999;
}
.dx-resizable-handle-left {
border-left: 1px dotted #999;
}
.dx-resizable-handle-bottom {
border-bottom: 1px dotted #999;
}
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 9px;
border: none;
border-radius: 50%;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-left::after {
top: 50%;
left: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-corner-top-left::after {
top: -4px;
left: -4px;
}
.dx-resizable-handle-corner-top-right::after {
top: -4px;
right: -4px;
}
.dx-resizable-handle-corner-bottom-left::after {
bottom: -4px;
left: -4px;
}
.dx-resizable-handle-corner-bottom-right::after {
bottom: -4px;
right: -4px;
}
.dx-resizable-handle-top::after {
top: -5px;
left: 50%;
transform: translateX(-50%);
}
.dx-resizable-handle-bottom::after {
bottom: -5px;
left: 50%;
transform: translateX(-50%);
}
const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2014/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2014/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2014/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2014/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2014/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2014/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2014/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2014/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2014/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2014/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2014/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2014/05/16',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2014/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2014/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2014/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2014/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2014/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2014/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2014/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2014/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2014/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2014/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2014/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2014/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2014/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2014/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2014/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2014/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2014/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2014/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2014/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2014/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2014/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2014/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2014/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2014/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2014/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2014/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2014/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2014/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
You can display resize handles on edges or corners. Use the following keywords to set up the handles property: top, bottom, left, and right. If you specify two adjacent sides (for example, "bottom right"), the control displays a handle in the corner.
The keepAspectRatio property specifies whether a corner handle resizes content proportionally. Set this property to false to allow free-form resize operations.

Backend API
<template>
<div>
<div class="widget-container">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Resizable DataGrid</div>
<div class="dx-field">
<DxResizable
:class="resizableClasses"
id="gridContainer"
:min-width="400"
:min-height="150"
:max-height="370"
:keep-aspect-ratio="keepAspectRatio"
:handles="handles.join(' ')"
area=".widget-container .dx-field"
>
<DxDataGrid
id="grid"
:data-source="orders"
key-expr="ID"
:show-borders="true"
height="100%"
>
<DxPaging :page-size="8"/>
<DxScrolling mode="virtual"/>
<DxColumn
:allow-grouping="false"
data-field="OrderNumber"
:width="130"
caption="Invoice Number"
/>
<DxColumn
data-field="CustomerStoreCity"
caption="City"
/>
<DxColumn
data-field="CustomerStoreState"
caption="State"
/>
<DxColumn data-field="Employee"/>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn
data-field="SaleAmount"
format="currency"
/>
</DxDataGrid>
</DxResizable>
</div>
</div>
</div>
<div class="options">
<div class="caption">Resizable Options</div>
<div class="option">
<div>Handles</div>
<DxTagBox
:items="handleValues"
:input-attr="{ 'aria-label': 'Handle' }"
v-model:value="handles"
/>
</div>
<div class="option">
<DxCheckBox
text="Keep aspect ratio"
v-model:value="keepAspectRatio"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import DxDataGrid, { DxPaging, DxScrolling, DxColumn } from 'devextreme-vue/data-grid';
import DxResizable from 'devextreme-vue/resizable';
import DxTagBox from 'devextreme-vue/tag-box';
import DxCheckBox from 'devextreme-vue/check-box';
import service from './data.ts';
const handleValues = ['left', 'top', 'right', 'bottom'];
const handles = ref(handleValues);
const keepAspectRatio = ref(true);
const orders = ref(service.getOrders());
const resizableClasses = computed(() => ({
'dx-resizable': true,
'no-left-handle': !handles.value.includes('left'),
'no-right-handle': !handles.value.includes('right'),
'no-top-handle': !handles.value.includes('top'),
'no-bottom-handle': !handles.value.includes('bottom'),
}));
</script>
<style src="./styles.css"></style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2014/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2014/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2014/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2014/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2014/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2014/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2014/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2014/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2014/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2014/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2014/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2014/05/16',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2014/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2014/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2014/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2014/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2014/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2014/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2014/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2014/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2014/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2014/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2014/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2014/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2014/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2014/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2014/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2014/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2014/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2014/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2014/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2014/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2014/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2014/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2014/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2014/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2014/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2014/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2014/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2014/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
export default {
getOrders() {
return orders;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
.widget-container {
width: calc(100% - 360px);
height: 100%;
margin-right: 320px;
position: absolute;
z-index: 1501;
}
.dx-fieldset,
.dx-field {
width: 100%;
height: calc(100% - 60px);
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
bottom: 0;
width: 260px;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 10px;
}
#gridContainer {
padding: 10px;
height: 300px;
}
#grid {
border: 1px solid black;
}
.no-left-handle .dx-resizable-handle-top,
.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 10px);
}
.no-right-handle .dx-resizable-handle-top,
.no-right-handle .dx-resizable-handle-bottom {
right: 10px;
width: calc(100% - 10px);
}
.no-right-handle.no-left-handle .dx-resizable-handle-top,
.no-right-handle.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 20px);
}
.no-top-handle .dx-resizable-handle-right,
.no-top-handle .dx-resizable-handle-left {
top: 10px;
height: calc(100% - 10px);
}
.no-bottom-handle .dx-resizable-handle-right,
.no-bottom-handle .dx-resizable-handle-left {
bottom: 10px;
height: calc(100% - 10px);
}
.no-top-handle.no-bottom-handle .dx-resizable-handle-left,
.no-top-handle.no-bottom-handle .dx-resizable-handle-right {
top: 10px;
height: calc(100% - 20px);
}
.dx-resizable-handle-right {
border-right: 1px dotted #999;
}
.dx-resizable-handle-top {
border-top: 1px dotted #999;
}
.dx-resizable-handle-left {
border-left: 1px dotted #999;
}
.dx-resizable-handle-bottom {
border-bottom: 1px dotted #999;
}
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 9px;
border: none;
border-radius: 50%;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-left::after {
top: 50%;
left: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-corner-top-left::after {
top: -4px;
left: -4px;
}
.dx-resizable-handle-corner-top-right::after {
top: -4px;
right: -4px;
}
.dx-resizable-handle-corner-bottom-left::after {
bottom: -4px;
left: -4px;
}
.dx-resizable-handle-corner-bottom-right::after {
bottom: -4px;
right: -4px;
}
.dx-resizable-handle-top::after {
top: -5px;
left: 50%;
transform: translateX(-50%);
}
.dx-resizable-handle-bottom::after {
bottom: -5px;
left: 50%;
transform: translateX(-50%);
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
You can display resize handles on edges or corners. Use the following keywords to set up the handles property: top, bottom, left, and right. If you specify two adjacent sides (for example, "bottom right"), the control displays a handle in the corner.
The keepAspectRatio property specifies whether a corner handle resizes content proportionally. Set this property to false to allow free-form resize operations.

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
import React, { useCallback, useState } from 'react';
import DataGrid, { Paging, Scrolling, Column } from 'devextreme-react/data-grid';
import Resizable from 'devextreme-react/resizable';
import CheckBox from 'devextreme-react/check-box';
import TagBox from 'devextreme-react/tag-box';
import { orders, handleLabel } from './data.ts';
const handleValues = ['left', 'top', 'right', 'bottom'];
const App = () => {
const [keepAspectRatio, setKeepAspectRatio] = useState(true);
const [handles, setHandles] = useState(handleValues);
const [resizableClasses, setResizableClasses] = useState('');
const keepAspectRatioValueChange = useCallback((value) => {
setKeepAspectRatio(value);
}, [setKeepAspectRatio]);
const handlesValueChange = useCallback((value: string[]) => {
const classes = handleValues.reduce((acc, handle) => {
const newClass = value.includes(handle) ? '' : ` no-${handle}-handle`;
return acc + newClass;
}, '');
setHandles(value);
setResizableClasses(classes);
}, [setHandles, setResizableClasses]);
return (
<React.Fragment>
<div className='widget-container'>
<div className='dx-fieldset'>
<div className='dx-fieldset-header'>Resizable DataGrid</div>
<div className='dx-field'>
<Resizable
className={resizableClasses}
id='gridContainer'
minWidth={400}
minHeight={150}
maxHeight={370}
keepAspectRatio={keepAspectRatio}
handles={handles.join(' ')}
area='.widget-container .dx-field'
>
<DataGrid
id='grid'
dataSource={orders}
keyExpr='ID'
showBorders={true}
height='100%'
>
<Paging pageSize={8} />
<Scrolling mode='virtual' />
<Column allowGrouping={false} dataField='OrderNumber' width={130} caption='Invoice Number' />
<Column dataField='CustomerStoreCity' caption='City' />
<Column dataField='CustomerStoreState' caption='State' />
<Column dataField='Employee' />
<Column dataField='OrderDate' dataType='date' />
<Column dataField='SaleAmount' format='currency' />
</DataGrid>
</Resizable>
</div>
</div>
</div>
<div className='options'>
<div className='caption'>Resizable Options</div>
<div className='option'>
<div>Handles</div>
<TagBox
items={handleValues}
value={handles}
inputAttr={handleLabel}
onValueChange={handlesValueChange}
/>
</div>
<div className='option'>
<CheckBox
text='Keep aspect ratio'
value={keepAspectRatio}
onValueChange={keepAspectRatioValueChange}
/>
</div>
</div>
</React.Fragment>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import DataGrid, { Paging, Scrolling, Column } from 'devextreme-react/data-grid';
import Resizable from 'devextreme-react/resizable';
import CheckBox from 'devextreme-react/check-box';
import TagBox from 'devextreme-react/tag-box';
import { orders, handleLabel } from './data.js';
const handleValues = ['left', 'top', 'right', 'bottom'];
const App = () => {
const [keepAspectRatio, setKeepAspectRatio] = useState(true);
const [handles, setHandles] = useState(handleValues);
const [resizableClasses, setResizableClasses] = useState('');
const keepAspectRatioValueChange = useCallback(
(value) => {
setKeepAspectRatio(value);
},
[setKeepAspectRatio],
);
const handlesValueChange = useCallback(
(value) => {
const classes = handleValues.reduce((acc, handle) => {
const newClass = value.includes(handle) ? '' : ` no-${handle}-handle`;
return acc + newClass;
}, '');
setHandles(value);
setResizableClasses(classes);
},
[setHandles, setResizableClasses],
);
return (
<React.Fragment>
<div className="widget-container">
<div className="dx-fieldset">
<div className="dx-fieldset-header">Resizable DataGrid</div>
<div className="dx-field">
<Resizable
className={resizableClasses}
id="gridContainer"
minWidth={400}
minHeight={150}
maxHeight={370}
keepAspectRatio={keepAspectRatio}
handles={handles.join(' ')}
area=".widget-container .dx-field"
>
<DataGrid
id="grid"
dataSource={orders}
keyExpr="ID"
showBorders={true}
height="100%"
>
<Paging pageSize={8} />
<Scrolling mode="virtual" />
<Column
allowGrouping={false}
dataField="OrderNumber"
width={130}
caption="Invoice Number"
/>
<Column
dataField="CustomerStoreCity"
caption="City"
/>
<Column
dataField="CustomerStoreState"
caption="State"
/>
<Column dataField="Employee" />
<Column
dataField="OrderDate"
dataType="date"
/>
<Column
dataField="SaleAmount"
format="currency"
/>
</DataGrid>
</Resizable>
</div>
</div>
</div>
<div className="options">
<div className="caption">Resizable Options</div>
<div className="option">
<div>Handles</div>
<TagBox
items={handleValues}
value={handles}
inputAttr={handleLabel}
onValueChange={handlesValueChange}
/>
</div>
<div className="option">
<CheckBox
text="Keep aspect ratio"
value={keepAspectRatio}
onValueChange={keepAspectRatioValueChange}
/>
</div>
</div>
</React.Fragment>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2014/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2014/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2014/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2014/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2014/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2014/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2014/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2014/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2014/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2014/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2014/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2014/05/16',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2014/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2014/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2014/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2014/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2014/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2014/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2014/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2014/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2014/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2014/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2014/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2014/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2014/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2014/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2014/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2014/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2014/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2014/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2014/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2014/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2014/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2014/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2014/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2014/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2014/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2014/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2014/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2014/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
export const handleLabel = { 'aria-label': 'Handle' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@25.1.3/cjs',
'devextreme-react': 'npm:devextreme-react@25.1.3/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.19/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.62/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const orders = [
{
ID: 1,
OrderNumber: 35703,
OrderDate: '2014/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 4,
OrderNumber: 35711,
OrderDate: '2014/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 5,
OrderNumber: 35714,
OrderDate: '2014/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 7,
OrderNumber: 35983,
OrderDate: '2014/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 9,
OrderNumber: 36987,
OrderDate: '2014/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 11,
OrderNumber: 38466,
OrderDate: '2014/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 14,
OrderNumber: 39420,
OrderDate: '2014/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 15,
OrderNumber: 39874,
OrderDate: '2014/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 18,
OrderNumber: 42847,
OrderDate: '2014/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 19,
OrderNumber: 43982,
OrderDate: '2014/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 29,
OrderNumber: 56272,
OrderDate: '2014/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 30,
OrderNumber: 57429,
OrderDate: '2014/05/16',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
{
ID: 32,
OrderNumber: 58292,
OrderDate: '2014/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 36,
OrderNumber: 62427,
OrderDate: '2014/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 39,
OrderNumber: 65977,
OrderDate: '2014/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 40,
OrderNumber: 66947,
OrderDate: '2014/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 42,
OrderNumber: 68428,
OrderDate: '2014/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 43,
OrderNumber: 69477,
OrderDate: '2014/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
},
{
ID: 46,
OrderNumber: 72947,
OrderDate: '2014/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 47,
OrderNumber: 73088,
OrderDate: '2014/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
},
{
ID: 50,
OrderNumber: 76927,
OrderDate: '2014/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 51,
OrderNumber: 77297,
OrderDate: '2014/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
{
ID: 56,
OrderNumber: 84744,
OrderDate: '2014/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 57,
OrderNumber: 85028,
OrderDate: '2014/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
},
{
ID: 59,
OrderNumber: 87297,
OrderDate: '2014/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 60,
OrderNumber: 88027,
OrderDate: '2014/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 65,
OrderNumber: 94726,
OrderDate: '2014/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 66,
OrderNumber: 95266,
OrderDate: '2014/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 69,
OrderNumber: 98477,
OrderDate: '2014/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
},
{
ID: 70,
OrderNumber: 99247,
OrderDate: '2014/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
},
{
ID: 78,
OrderNumber: 174884,
OrderDate: '2014/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 81,
OrderNumber: 188877,
OrderDate: '2014/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
{
ID: 82,
OrderNumber: 191883,
OrderDate: '2014/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
},
{
ID: 83,
OrderNumber: 192474,
OrderDate: '2014/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
},
{
ID: 84,
OrderNumber: 193847,
OrderDate: '2014/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
},
{
ID: 85,
OrderNumber: 194877,
OrderDate: '2014/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
},
{
ID: 86,
OrderNumber: 195746,
OrderDate: '2014/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
},
{
ID: 87,
OrderNumber: 197474,
OrderDate: '2014/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
},
{
ID: 88,
OrderNumber: 198746,
OrderDate: '2014/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
},
{
ID: 91,
OrderNumber: 214222,
OrderDate: '2014/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
},
];
export const handleLabel = { 'aria-label': 'Handle' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.widget-container {
width: calc(100% - 360px);
height: 100%;
margin-right: 320px;
position: absolute;
z-index: 1501;
}
.dx-fieldset,
.dx-field {
width: 100%;
height: calc(100% - 60px);
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
bottom: 0;
width: 260px;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 10px;
}
#gridContainer {
padding: 10px;
height: 300px;
}
#grid {
border: 1px solid black;
}
.no-left-handle .dx-resizable-handle-top,
.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 10px);
}
.no-right-handle .dx-resizable-handle-top,
.no-right-handle .dx-resizable-handle-bottom {
right: 10px;
width: calc(100% - 10px);
}
.no-right-handle.no-left-handle .dx-resizable-handle-top,
.no-right-handle.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 20px);
}
.no-top-handle .dx-resizable-handle-right,
.no-top-handle .dx-resizable-handle-left {
top: 10px;
height: calc(100% - 10px);
}
.no-bottom-handle .dx-resizable-handle-right,
.no-bottom-handle .dx-resizable-handle-left {
bottom: 10px;
height: calc(100% - 10px);
}
.no-top-handle.no-bottom-handle .dx-resizable-handle-left,
.no-top-handle.no-bottom-handle .dx-resizable-handle-right {
top: 10px;
height: calc(100% - 20px);
}
.dx-resizable-handle-right {
border-right: 1px dotted #999;
}
.dx-resizable-handle-top {
border-top: 1px dotted #999;
}
.dx-resizable-handle-left {
border-left: 1px dotted #999;
}
.dx-resizable-handle-bottom {
border-bottom: 1px dotted #999;
}
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 9px;
border: none;
border-radius: 50%;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-left::after {
top: 50%;
left: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-corner-top-left::after {
top: -4px;
left: -4px;
}
.dx-resizable-handle-corner-top-right::after {
top: -4px;
right: -4px;
}
.dx-resizable-handle-corner-bottom-left::after {
bottom: -4px;
left: -4px;
}
.dx-resizable-handle-corner-bottom-right::after {
bottom: -4px;
right: -4px;
}
.dx-resizable-handle-top::after {
top: -5px;
left: 50%;
transform: translateX(-50%);
}
.dx-resizable-handle-bottom::after {
bottom: -5px;
left: 50%;
transform: translateX(-50%);
}
You can display resize handles on edges or corners. Use the following keywords to set up the handles property: top, bottom, left, and right. If you specify two adjacent sides (for example, "bottom right"), the control displays a handle in the corner.
The keepAspectRatio property specifies whether a corner handle resizes content proportionally. Set this property to false to allow free-form resize operations.

Backend API
<div class="widget-container">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Resizable DataGrid</div>
<div class="dx-field">
<dx-resizable
[class]="resizableClasses"
id="gridContainer"
[minWidth]="400"
[minHeight]="150"
[maxHeight]="370"
[keepAspectRatio]="keepAspectRatio"
[handles]="handles.join(' ')"
area=".widget-container .dx-field"
>
<dx-data-grid
id="grid"
[dataSource]="orders"
keyExpr="ID"
[showBorders]="true"
height="100%"
>
<dxo-paging [pageSize]="8"></dxo-paging>
<dxo-scrolling mode="virtual"></dxo-scrolling>
<dxi-column
[allowGrouping]="false"
dataField="OrderNumber"
[width]="130"
caption="Invoice Number"
></dxi-column>
<dxi-column dataField="CustomerStoreCity" caption="City"></dxi-column>
<dxi-column
dataField="CustomerStoreState"
caption="State"
></dxi-column>
<dxi-column dataField="Employee"></dxi-column>
<dxi-column dataField="OrderDate" dataType="date"></dxi-column>
<dxi-column dataField="SaleAmount" format="currency"></dxi-column>
</dx-data-grid>
</dx-resizable>
</div>
</div>
</div>
<div class="options">
<div class="caption">Resizable Options</div>
<div class="option">
<div>Handles</div>
<dx-tag-box
[items]="handleValues"
[(value)]="handles"
[inputAttr]="{ 'aria-label': 'Handle' }"
(onValueChanged)="handlesValueChange($event)"
></dx-tag-box>
</div>
<div class="option">
<dx-check-box
text="Keep aspect ratio"
[(value)]="keepAspectRatio"
></dx-check-box>
</div>
</div>
import {
NgModule, Component, enableProdMode, ViewEncapsulation,
} from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxResizableModule,
DxDataGridModule,
DxTagBoxModule,
DxCheckBoxModule,
} from 'devextreme-angular';
import { Service, Order } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
handleValues: string[] = ['left', 'top', 'right', 'bottom'];
keepAspectRatio = true;
handles: string[] = ['left', 'top', 'right', 'bottom'];
orders: Order[];
resizableClasses = '';
constructor(service: Service) {
this.orders = service.getOrders();
}
handlesValueChange({ value }) {
this.resizableClasses = this.handleValues.reduce((acc, handle) => {
const newClass = value.includes(handle) ? '' : ` no-${handle}-handle`;
return acc + newClass;
}, 'dx-resizable');
}
}
@NgModule({
imports: [
BrowserModule,
DxResizableModule,
DxDataGridModule,
DxCheckBoxModule,
DxTagBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
.widget-container {
width: calc(100% - 360px);
height: 100%;
margin-right: 320px;
position: absolute;
z-index: 1501;
}
.dx-fieldset,
.dx-field {
width: 100%;
height: calc(100% - 60px);
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
bottom: 0;
width: 260px;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 10px;
}
#gridContainer {
padding: 10px;
height: 300px;
}
#grid {
border: 1px solid black;
}
.no-left-handle .dx-resizable-handle-top,
.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 10px);
}
.no-right-handle .dx-resizable-handle-top,
.no-right-handle .dx-resizable-handle-bottom {
right: 10px;
width: calc(100% - 10px);
}
.no-right-handle.no-left-handle .dx-resizable-handle-top,
.no-right-handle.no-left-handle .dx-resizable-handle-bottom {
left: 10px;
width: calc(100% - 20px);
}
.no-top-handle .dx-resizable-handle-right,
.no-top-handle .dx-resizable-handle-left {
top: 10px;
height: calc(100% - 10px);
}
.no-bottom-handle .dx-resizable-handle-right,
.no-bottom-handle .dx-resizable-handle-left {
bottom: 10px;
height: calc(100% - 10px);
}
.no-top-handle.no-bottom-handle .dx-resizable-handle-left,
.no-top-handle.no-bottom-handle .dx-resizable-handle-right {
top: 10px;
height: calc(100% - 20px);
}
.dx-resizable-handle-right {
border-right: 1px dotted #999;
}
.dx-resizable-handle-top {
border-top: 1px dotted #999;
}
.dx-resizable-handle-left {
border-left: 1px dotted #999;
}
.dx-resizable-handle-bottom {
border-bottom: 1px dotted #999;
}
.dx-resizable-handle::after {
content: "";
position: absolute;
width: 9px;
height: 9px;
border: none;
border-radius: 50%;
background-color: #fff;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.24);
}
.dx-resizable-handle-right::after {
top: 50%;
right: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-left::after {
top: 50%;
left: -5px;
transform: translateY(-50%);
}
.dx-resizable-handle-corner-top-left::after {
top: -4px;
left: -4px;
}
.dx-resizable-handle-corner-top-right::after {
top: -4px;
right: -4px;
}
.dx-resizable-handle-corner-bottom-left::after {
bottom: -4px;
left: -4px;
}
.dx-resizable-handle-corner-bottom-right::after {
bottom: -4px;
right: -4px;
}
.dx-resizable-handle-top::after {
top: -5px;
left: 50%;
transform: translateX(-50%);
}
.dx-resizable-handle-bottom::after {
bottom: -5px;
left: 50%;
transform: translateX(-50%);
}
import { Injectable } from '@angular/core';
export class Order {
ID: number;
OrderNumber: number;
OrderDate: string;
SaleAmount: number;
Terms: string;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee: string;
}
const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2014/04/10',
SaleAmount: 11800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2014/01/12',
SaleAmount: 16050,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2014/01/22',
SaleAmount: 14750,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2014/02/07',
SaleAmount: 3725,
Terms: '15 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: '2014/03/11',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2014/03/01',
SaleAmount: 7800,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2014/02/15',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2014/02/04',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2014/02/15',
SaleAmount: 20400,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: '2014/05/29',
SaleAmount: 6050,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: '2014/02/06',
SaleAmount: 15850,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2014/05/16',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2014/05/13',
SaleAmount: 13500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2014/01/27',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2014/02/05',
SaleAmount: 2550,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: '2014/03/23',
SaleAmount: 3500,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2014/04/10',
SaleAmount: 10500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2014/03/09',
SaleAmount: 14200,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2014/01/14',
SaleAmount: 13350,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2014/03/25',
SaleAmount: 8600,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: '2014/04/27',
SaleAmount: 9800,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2014/04/30',
SaleAmount: 10850,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2014/02/10',
SaleAmount: 4650,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2014/05/17',
SaleAmount: 2575,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2014/04/21',
SaleAmount: 14200,
Terms: '30 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: '2014/02/14',
SaleAmount: 13650,
Terms: '30 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2014/05/22',
SaleAmount: 20500,
Terms: '15 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2014/03/10',
SaleAmount: 9050,
Terms: '15 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2014/01/01',
SaleAmount: 23500,
Terms: '15 Days',
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: '2014/02/08',
SaleAmount: 2100,
Terms: '15 Days',
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2014/04/10',
SaleAmount: 7200,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2014/02/11',
SaleAmount: 8750,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2014/02/05',
SaleAmount: 9900,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2014/01/21',
SaleAmount: 12800,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2014/03/21',
SaleAmount: 14100,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2014/03/06',
SaleAmount: 4750,
Terms: '30 Days',
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2014/05/26',
SaleAmount: 9050,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2014/03/02',
SaleAmount: 6400,
Terms: '30 Days',
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2014/05/09',
SaleAmount: 15700,
Terms: '30 Days',
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2014/02/08',
SaleAmount: 11050,
Terms: '30 Days',
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
@Injectable()
export class Service {
getOrders() {
return orders;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
You can display resize handles on edges or corners. Use the following keywords to set up the handles property: top, bottom, left, and right. If you specify two adjacent sides (for example, "bottom right"), the control displays a handle in the corner.
The keepAspectRatio property specifies whether a corner handle resizes content proportionally. Set this property to false to allow free-form resize operations.